package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolMajorTagBo;
import org.dromara.art.domain.vo.ArtSchoolMajorTagVo;
import org.dromara.art.domain.ArtSchoolMajorTag;
import org.dromara.art.mapper.ArtSchoolMajorTagMapper;
import org.dromara.art.service.IArtSchoolMajorTagService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 专业标签Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolMajorTagServiceImpl implements IArtSchoolMajorTagService {

    private final ArtSchoolMajorTagMapper baseMapper;

    /**
     * 查询专业标签
     *
     * @param majorTagId 主键
     * @return 专业标签
     */
    @Override
    public ArtSchoolMajorTagVo queryById(Long majorTagId){
        return baseMapper.selectVoById(majorTagId);
    }

    /**
     * 分页查询专业标签列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 专业标签分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolMajorTagVo> queryPageList(ArtSchoolMajorTagBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolMajorTag> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolMajorTagVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的专业标签列表
     *
     * @param bo 查询条件
     * @return 专业标签列表
     */
    @Override
    public List<ArtSchoolMajorTagVo> queryList(ArtSchoolMajorTagBo bo) {
        LambdaQueryWrapper<ArtSchoolMajorTag> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolMajorTag> buildQueryWrapper(ArtSchoolMajorTagBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolMajorTag> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolMajorTag::getMajorTagId);
        lqw.eq(bo.getMajorId() != null, ArtSchoolMajorTag::getMajorId, bo.getMajorId());
        lqw.like(StringUtils.isNotBlank(bo.getTagName()), ArtSchoolMajorTag::getTagName, bo.getTagName());
        return lqw;
    }

    /**
     * 新增专业标签
     *
     * @param bo 专业标签
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolMajorTagBo bo) {
        ArtSchoolMajorTag add = MapstructUtils.convert(bo, ArtSchoolMajorTag.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setMajorTagId(add.getMajorTagId());
        }
        return flag;
    }

    /**
     * 修改专业标签
     *
     * @param bo 专业标签
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolMajorTagBo bo) {
        ArtSchoolMajorTag update = MapstructUtils.convert(bo, ArtSchoolMajorTag.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolMajorTag entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除专业标签信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
